/*
 * Part of the GaBIEn project.
 * (Graphics and Basic Input Engine)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package gabien;

/**
 * Represents a 22050 hertz sound system.
 * @author matt
 */
public interface ISoundDriver {
    
    public static interface IChannel {
        //Note that this ALWAYS loops.
        public void PlaySound(double Pitch,double VolL,double VolR,short[] sound);
        public void SetVolume(double VolL,double VolR);
        public double VolL();
        public double VolR();
    }
    public IChannel CreateChannel();
    public void DeleteChannel(IChannel ic);
    public void Shutdown();
}
