/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan;

/**
 * A physics engine! Basically,this pushes objects out of other objects and the world.
 * Then it zeroes the involved parts of object velocity.
 * Anyone who wants to implement this should note:
 * Collision with the non-solid parts of the world should be handled AFTER collision with solids,
 * or you may make a bad mistake and have somebody accidentally spike themselves for no reason.
 * Furthermore,the difference between NPCs and Bosses is that Bosses are singletons(relative to GameState).
 * Just call Exists,if it's true,then Ikachan(AND ONLY IKACHAN) collides with this object.
 * Colliding with a boss causes a call to the boss "hit" function.
 * @author matt
 */
public interface IPhysicsEngine {
    //If gs==ipo,then ev shouldn't be null.
    public boolean[] Calculate(IEventCallback ev, IPhysicsObject ipo, GameState gs, double InGameTime);
}
