/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.games;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.logging.Level;
import java.util.logging.Logger;
import javachan.Game;
import javachan.GameState;
import javachan.IEventCallback;
import javachan.IGame;
import gabien.GaBIEn;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import javachan.IPhysicsEngine;

/**
 *
 * @author matt
 */
public class MainGame implements IGame,IEventCallback {
    public static final double TickLen=0.025;
    public double DCamX=0,DCamY=0;
    public GameState gs=new GameState();
    public int ScriptPoint;
    public String CurrentChat=null;
    public int CurrentChatReveal=0;
    public String ChatState="";
    public boolean ShowMap=false;
    public double TickTimer=0;
    public double FadeTimer=0;//Fades apparently don't pause the script.
    public boolean ThisIsEndingFade=false;
    public boolean ReturningFromMaru=false;
    public int FadeState=0;
    public int SavedLR=0;//used for displaying Ikachan
    public IPhysicsEngine physics=new PhysicsImplementation();
    //SCRIPT STATE VARIABLES
    public int LEL=0;//Last Event Lookup
    public int SelectedItem=0;
    public int MajorState=0;//0:Startup,1:Main Game
                            //All MinorStates except 0 mean paused.
    public int MinorState=0;//0:None,1:Pause Script For Chat,2:Pause Script For (Yes) No,3:Pause Script For Yes (No),4:Pause Script For Transient Chat,5:Pause Script For Time,6:Pause Script For Items
    public int YesDest=0;//Y/N
    public double GeneralMinorUseTimer=0;//for minors
    //END SCRIPT STATE VARIABLES
    public boolean RunScriptCommand(double Delta,Game g)
    {
        String s=GetLine(ScriptPoint++);
        System.out.println("Script line execution:"+s);
        if (s.startsWith("<"))
        {
            //COMMANDS
            if (s.startsWith("<e+"))
            {
                gs.PlayerEnergy=gs.GetMaxEnergy();
                return false;
            }
            if (s.startsWith("<ex"))
            {
                System.exit(0);
                return false;
            }
            if (s.startsWith("<re"))
            {
                gs.RestoreCharacterPosition();
                return false;
            }
            if (s.startsWith("<yn"))
            {
                YesDest=LookupEvent(ParseInt(s.substring(3)))+1;
                MinorState=2;
                return false;
            }
            if (s.startsWith("<ge"))
            {
                gs.InitGreatEscape();
                return true;
            }
            if (s.startsWith("<bo"))
            {
                gs.BossMode=true;
                gs.Bosses[gs.BossID].InitBattle();
                gs.BossID=ParseInt(s.substring(3));
                return false;
            }
            if (s.startsWith("<pd"))
            {
                String r="Pmd/Tidepool.pmd";
                int i=ParseInt(s.substring(3));
                if (i==0)
                {
                    r="Pmd/Ikachan.pmd";
                }
                if (i==1)
                {
                    r="Pmd/Magirete.pmd";
                }
                if (i==2)
                {
                    r="Pmd/Buriki.pmd";
                }
                if (i==3)
                {
                    r="Pmd/Mizuno.pmd";
                }
                if (i==4)
                {
                    r="Pmd/Quake.pmd";
                }
                g.music.SetMusic(r);
                return true;
            }
            if (s.startsWith("<pp"))
            {
                g.music.PlayMusic();
                return true;
            }
            if (s.startsWith("<ps"))
            {
                g.music.StopMusic();
                return true;
            }
            if (s.startsWith("<fi"))
            {
                FadeState=1;
                FadeTimer=0;
                return true;
            }
            if (s.startsWith("<fo"))
            {
                FadeState=2;
                FadeTimer=0;
                return true;
            }
            if (s.startsWith("<ec"))
            {
                gs.EntityCount++;
                return true;
            }
            if (s.startsWith("<fj"))
            {
                if (gs.Flags[ParseInt(s.substring(3))])
                    ScriptPoint=LookupEvent(ParseInt(s.substring(8)))+1;
                return true;
            }
            if (s.startsWith("<ij"))
            {
                int pi=ParseInt(s.substring(3));
                for (int xx=0;xx<gs.Items.length;xx++)
                {
                    if (gs.Items[xx]==pi)
                    {
                        ScriptPoint=LookupEvent(ParseInt(s.substring(8)))+1;
                        break;//Welp,we're done here.
                    }
                }
                return true;
            }
            if (s.startsWith("<ej"))
            {
                if (ParseInt(s.substring(3))==gs.EntityCount)
                    ScriptPoint=LookupEvent(ParseInt(s.substring(8)))+1;
                return true;
            }
            if (s.startsWith("<nm"))
            {
                ShowMap=true;
                return true;
            }
            if (s.startsWith("<ma"))
            {
                ShowMap=false;
                return true;
            }
            if (s.startsWith("<i+"))
            {
                for (int xx=0;xx<gs.Items.length;xx++)
                {
                    if (gs.Items[xx]==0)
                    {
                    gs.Items[xx]=ParseInt(s.substring(3));
                    break;//mystery solved!
                    }
                }
                return true;
            }
            if (s.startsWith("<i-"))
            {
                int pi=ParseInt(s.substring(3));
                for (int xx=0;xx<gs.Items.length;xx++)
                {
                    if (gs.Items[xx]==pi)
                    {
                    gs.Items[xx]=0;
                    break;
                    }
                }
                return true;
            }
            if (s.startsWith("<f+"))
            {
                gs.Flags[ParseInt(s.substring(3))]=true;
                return true;
            }
            if (s.startsWith("<cm"))
            {
                int npcc=ParseInt(s.substring(3));
                int npcx=ParseInt(s.substring(3+5));
                int npcy=ParseInt(s.substring(3+5+5));
                gs.npcs.chars[npcc].X=npcx;
                gs.npcs.chars[npcc].Y=npcy;
                if (npcx==0)
                if (npcy==0)
                    gs.npcs.chars[npcc].Exists=false;
                return true;
            }
            if (s.startsWith("<wa"))
            {
                int pca=ParseInt(s.substring(3));
                CurrentChat=null;
                ChatState="";
                MinorState=5;//5 is safe to use while CurrentChat==null.
                GeneralMinorUseTimer=pca*TickLen;
                return false;
            }
            if (s.startsWith("<pc"))
            {
                int pca=ParseInt(s.substring(3));
                int pcb=ParseInt(s.substring(3+5));
                int pcc=ParseInt(s.substring(3+5+5));
                gs.map.data[pca+(pcb*gs.map.Width)]=pcc;
                return true;
            }
            if (s.startsWith("<end"))
            {
                if (MajorState==0)
                {
                    MajorState=1;
                    ScriptPoint=LookupEvent(2)+1;
                        g.graphics.ClearKeys();
                    g.music.StopMusic();
                    if (g.graphics.IsKeyDown(Keymap.VK_ITEMS))
                    {
                        g.gamestate=new EditorGame(gs);
                    } else {
                        g.music.SetMusic("Pmd/Magirete.pmd");
                        g.music.PlayMusic();
                        ReturningFromMaru=true;
                        g.gamestate=new EndingGame(true,this);
                    }
                } else if (MajorState==2) {
                    ScriptPoint=LookupEvent(6)+1;
                    MajorState=1;
                } else {
                ScriptPoint=-1;
                }
                return false;
            }
            System.out.println("NYI:"+s);
            return true;
        } else {
            
            if (s.endsWith("/"))
            {
                s=s.substring(0,s.length()-1);
                MinorState=1;
            } else {
                MinorState=4;
            }
            String LastChatState=ChatState;
            if (s.endsWith("+"))
            {
                s=s.substring(0,s.length()-1);
                ChatState="+";
            } else {
                ChatState="";
            }
            if (LastChatState.equals("+"))
            {
            CurrentChat+="\r\n"+s;
            } else {
            GeneralMinorUseTimer=0;
            CurrentChat=s;
            CurrentChatReveal=0;
            }
            return false;//needs to get on the screen :)
        }
    }
    public MainGame()
    {
        StartEvent(1);
        try {
            gs.map.LoadBitmap(GaBIEn.GetFile("Pbm/Map1.pbm"));
            gs.npcs.Load(GaBIEn.GetFile("NPChar.dat"));
        } catch (Exception ex) {
            Logger.getLogger(MainGame.class.getName()).log(Level.SEVERE, "Couldn't load main map!!!", ex);
        }
    }
    //This function is structured so the JustPress functions do only get called once.
    //Just look carefully at the code paths...(really really carefully!)
    @Override
    public void Run(double DeltaTime, double Time, Game g) {
        if (ReturningFromMaru)
        {
            ReturningFromMaru=false;
            g.music.SetMusic("Pmd/Ikachan.pmd");
        }
        /* CHEAT
        if (g.graphics.GetMouseJustDown())
        {
            gs.PlayerLevel=6;
            gs.PlayerEnergy=gs.GetMaxEnergy();
            gs.Items[0]=1;
            if (u==0)
            {
            gs.PlayerX=49;
            gs.PlayerY=35;
            }
            if (u==1)
            {
            gs.PlayerX=122;
            gs.PlayerY=91;
            gs.Items[1]=8;
            }
            u++;
        }*/
        TickTimer+=DeltaTime;
        boolean TickNow=false;
        if (TickTimer>TickLen)
        {
            TickTimer-=TickLen;
            TickNow=true;
        }
        
        //--------------------------UPDATE
        if (MinorState==0)
        {
        if (ScriptPoint!=-1)
        {
            //Run until signal given 'done for this frame'
            while (RunScriptCommand(DeltaTime,g)) {}
        }
        }
        boolean MinorStateSwimFlag=false;
        boolean MinorStateLFlag=false;
        boolean MinorStateRFlag=false;
        boolean MinorStateItemsFlag=false;
        //now,after that is done,re-test
        if (ScriptPoint==-1)
        {
            if (gs.PlayerDead)
            {
                MajorState=2;
                ScriptPoint=-5;
            }
            CurrentChat=null;//done with chat,no script running==no chat!
            ChatState="";
            MinorState=0;//Since we've just Nulled out CurrentChat,better turn off minorstates
            //PHYSICS
            gs.InGameTime+=DeltaTime;
            int LR=0;
            if (g.graphics.IsKeyDown(Keymap.VK_LEFT)) LR=-1;
            if (g.graphics.IsKeyDown(Keymap.VK_RIGHT)) LR=1;
            //During normal gameplay,only grab Swim on tick boundaries.
            //During scripting,grab it at all times because we're getting called all the time
            //(instead of on tick boundaries.)

            //Make sure these buffers are 0,lest we go into a minorstate unprepared :)
            //We can't use clearkeys as that would break Swim.
            g.graphics.IsKeyJustPressed(Keymap.VK_LEFT);
            g.graphics.IsKeyJustPressed(Keymap.VK_RIGHT);
            if (gs.GreatEscape) LR=0;
            if (TickNow)
            {
                gs.particles.Tick();
                if (gs.GreatEscape)
                {
                    gs.GreatEscapeTick();
                    gs.MainNPCTick(physics, gs.InGameTime);
                } else {
                    gs.BossesTick();
                    gs.MainTick(LR,g.graphics.IsKeyJustPressed(Keymap.VK_SWIM),g.graphics.IsKeyDown(Keymap.VK_SWIM),physics,(IEventCallback)this,gs.InGameTime);
                    gs.MainNPCTick(physics, gs.InGameTime);
                }
                if (gs.PlayerY<0)
                {
                    if (FadeState==0)
                    {
                        if (ThisIsEndingFade)
                        {
                            g.music.StopMusic();
                            g.music.SetMusic("Pmd/Tidepool.pmd");
                            g.music.PlayMusic();
                            g.graphics.ClearKeys();
                            g.gamestate=new EndingGame(false,new OpeningGame());
                            //just do nothing-graphics won't flush,so it'll look fine
                            return;
                        } else {
                        FadeState=2;
                        FadeTimer=0;
                        ThisIsEndingFade=true;
                        }
                    } else {
                    }
                }
            }
            if (g.graphics.IsKeyJustPressed(Keymap.VK_ITEMS))
            {
                //If we're not in a script(physics could relatively easily cause a problem)...
                if (ScriptPoint==-1)
                {
                    ScriptPoint=-2;
                    MinorState=6;
                    SelectedItem=0;
                }
            }
            
            SavedLR=LR;
        } else {
            MinorStateItemsFlag=g.graphics.IsKeyJustPressed(Keymap.VK_ITEMS);
            MinorStateSwimFlag=g.graphics.IsKeyJustPressed(Keymap.VK_SWIM);
            MinorStateLFlag=g.graphics.IsKeyJustPressed(Keymap.VK_LEFT);
            MinorStateRFlag=g.graphics.IsKeyJustPressed(Keymap.VK_RIGHT);
        }
        
        //--------------------------DRAWING
        
        g.graphics.Clear(0,0,0);
        //draw map here,ikachan included at no extra cost.
        //RENDERING.Call in this order:RenderBack,Map.Render(pass 0),NPChar.Render,RenderPC,Map.Render(pass 1)
        double TCamX=-((gs.PlayerX*16)-(g.graphics.GetWidth()/2));
        double TCamY=-((gs.PlayerY*16)-(g.graphics.GetHeight()/2));
        DCamX+=((TCamX-DCamX)/64)*1;
        DCamY+=((TCamY-DCamY)/64)*1;
        int CamX=(int)DCamX;
        int CamY=(int)DCamY;
        //yes,this is cheating.
        if (CamX>0)
        {
            CamX=0;
        }
        if (CamY>0)
        {
            CamY=0;
        }
        if (ShowMap)
        {
            gs.RenderBack(CamX,CamY, Time, g.graphics);
                gs.map.RenderTiles(CamX,CamY, 0, Time, g.graphics);
                    gs.npcs.Render(CamX, CamY, gs.InGameTime,gs,g.graphics);
                    gs.RenderPC(CamX, CamY, SavedLR, g.graphics,gs.InGameTime);
                gs.map.RenderTiles(CamX,CamY, 1, Time, g.graphics);
                gs.particles.Draw(CamX, CamY, g.graphics);
        }
        if (CurrentChat!=null)
        {
            IImage chatbox=g.graphics.GetImage("Pbm/Msgbox.pbm", 0,0,0);
            String c=CurrentChat.substring(0, CurrentChatReveal);
            g.graphics.BlitBCKImage(0, 0, chatbox.GetWidth(), chatbox.GetHeight(), 10, g.graphics.GetHeight()-(chatbox.GetHeight()+9), chatbox);
            if (c.length()>0)
            {
            String co=c;
            if (co.indexOf("\r\n")!=-1)
            {
                co=co.substring(0, co.indexOf("\r\n"));
            }
            g.graphics.Display8pxText(20, (g.graphics.GetHeight()+2)-(chatbox.GetHeight()+1), 0, 0, 255, co);
            g.graphics.Display8pxText(18, g.graphics.GetHeight()-(chatbox.GetHeight()+1), 255, 255, 255, co);
            if (c.split("\r\n").length>1)
            {
            g.graphics.Display8pxText(20, (g.graphics.GetHeight()+2)-(chatbox.GetHeight()-11), 0, 0, 255, c.split("\r\n")[1]);
            g.graphics.Display8pxText(18, g.graphics.GetHeight()-(chatbox.GetHeight()-11), 255, 255, 255, c.split("\r\n")[1]);
            }
            }
        }
        if (ScriptPoint==-1)
        {
            IImage statspage=g.graphics.GetImage("Pbm/Status.pbm", 0,0,0);
            int b=8;
            int d=48;
            g.graphics.BlitBCKImage(0, 0, statspage.GetWidth(), statspage.GetHeight(), b,b, statspage);
            DrawFigure(g.graphics,gs.PlayerLevel,b+d,b);
            DrawFigure(g.graphics,gs.PlayerXP,b+d,b+8);
            DrawFigure(g.graphics,gs.PlayerEnergy,b+d,b+16);

            DrawFigure(g.graphics,gs.GetMaxXP(),b+(statspage.GetWidth()-8),b+8);
            DrawFigure(g.graphics,gs.GetMaxEnergy(),b+(statspage.GetWidth()-8),b+16);
        }
        //---------------------------MINOR STATE HANDLERS--------------------------------
        //both update and drawing.
        double ChatSpeed=15;
        if (MinorState==1)
        {
            GeneralMinorUseTimer+=DeltaTime*ChatSpeed;
            if (g.graphics.IsKeyDown(Keymap.VK_SWIM))
            {
            GeneralMinorUseTimer+=DeltaTime*ChatSpeed;
            }
            CurrentChatReveal=(int)GeneralMinorUseTimer;
            String CurrentChatUsable=CurrentChat;
            if (CurrentChatUsable.contains("\r\n"))
            {
            CurrentChatUsable=CurrentChat.split("\r\n")[0];
            if (CurrentChat.split("\r\n").length>=2)
                CurrentChatUsable+="\r\n"+CurrentChat.split("\r\n")[1];
            }
            if (GeneralMinorUseTimer>CurrentChatUsable.length())
            {
                IImage tinyguy=g.graphics.GetImage("Pbm/Cursor.pbm", 0,0,0);//cute star thing.
                int frame=((int)(Time*10))%6;
                g.graphics.BlitBCKImage(48+((frame>3)?((frame-2)*8):(frame*8)), (frame>3)?0:16, 8, 16, 295, g.graphics.GetHeight()-27, tinyguy);
                CurrentChatReveal=CurrentChatUsable.length();
            if (g.graphics.IsKeyDown(Keymap.VK_SWIM))
            {
                AdvanceChat();
            }
                GeneralMinorUseTimer=CurrentChatReveal;
            }
        }
        if (MinorState==2)
        {
            if (MinorStateLFlag)
            {
                //L
                MinorState=2;
            }
            if (MinorStateRFlag)
            {
                //R
                MinorState=3;
            }
            if (MinorStateSwimFlag)
            {
                MinorState=0;
                ScriptPoint=YesDest;
            }
            DrawYN(g.graphics,true);
        }
        if (MinorState==3)
        {
            if (MinorStateLFlag)
            {
                //L
                MinorState=2;
            }
            if (MinorStateRFlag)
            {
                //R
                MinorState=3;
            }
            if (MinorStateSwimFlag)
            {
                MinorState=0;
            }
            DrawYN(g.graphics,false);
        }
        if (MinorState==4)
        {
            String CurrentChatUsable=CurrentChat;
            if (CurrentChatUsable.contains("\r\n"))
            {
            CurrentChatUsable=CurrentChat.split("\r\n")[0];
            if (CurrentChat.split("\r\n").length>=2)
                CurrentChatUsable+="\r\n"+CurrentChat.split("\r\n")[1];
            }
            GeneralMinorUseTimer+=DeltaTime*ChatSpeed;
            if (g.graphics.IsKeyDown(Keymap.VK_SWIM))
            {
            GeneralMinorUseTimer+=DeltaTime*ChatSpeed;
            }
            CurrentChatReveal=(int)GeneralMinorUseTimer;
            if (CurrentChatReveal>CurrentChatUsable.length())
            {
                CurrentChatReveal=CurrentChatUsable.length();
                AdvanceChat();//This will either leave chat or set CurrentChatReveal.
                GeneralMinorUseTimer=CurrentChatReveal;
            }
        }
        if (MinorState==5)
        {
            if (TickNow)
            {
                //And now you know how <wa updates Isogin instances.
                    gs.MainNPCTick(physics, gs.InGameTime);
                gs.particles.Tick();
            }
            GeneralMinorUseTimer-=DeltaTime;
            if (GeneralMinorUseTimer<=0) MinorState=0;
        }
        if (MinorState==6)
        {
            if (MinorStateItemsFlag) MinorState=0;//leave itembox
            if (MinorStateLFlag)
            {
                SelectedItem--;
            }
            if (MinorStateRFlag)
            {
                SelectedItem++;
            }
            if (MinorStateSwimFlag)
            {
                int ti=gs.Items[SelectedItem];
                if (ti!=0)
                {
                MinorState=0;
                StartEvent(ti+2000);
                }
            }
            while (SelectedItem<0) SelectedItem+=gs.Items.length;
            while (SelectedItem>=gs.Items.length) SelectedItem-=gs.Items.length;
            IImage ItemBox=g.graphics.GetImage("Pbm/ItemBox.pbm", 0, 0, 0);
            IImage Items=g.graphics.GetImage("Pbm/Item.pbm", 0, 0, 0);
            IImage Cursor=g.graphics.GetImage("Pbm/Cursor.pbm", 0, 0, 0);
            int ibx=(g.graphics.GetWidth()/2)-(ItemBox.GetWidth()/2);
            int iby=(g.graphics.GetHeight()/2)-(ItemBox.GetHeight()/2);
            g.graphics.BlitImage(0, 0, g.graphics.GetWidth(), g.graphics.GetHeight(), ibx, (g.graphics.GetHeight()/2)-(ItemBox.GetHeight()/2), ItemBox);
            for (int i=0;i<gs.Items.length;i++)
            {
                int p=((gs.Items[i]-1)*16);
                if (gs.Items[i]!=0)
                {
                g.graphics.BlitImage(p, 0, 16, 16, ibx+8+(i*16), iby+8, Items);
                }
            }
            g.graphics.BlitBCKImage(32, 0, 16, 16, ibx+8+(SelectedItem*16), iby+8, Cursor);
        }
        //---------------------FADES(GOES ON TOP OF EVERYTHING ELSE)
        if (FadeState==1)
        {
            FadeTimer+=DeltaTime*32;
            if (FadeDrawer((int)FadeTimer,false,g.graphics)) FadeState=0;
        }
        if (FadeState==2)
        {
            FadeTimer+=DeltaTime*32;
            if (FadeDrawer((int)FadeTimer,true,g.graphics)) FadeState=0;
        }
        g.graphics.Flush();
    }
    //lines start at 1.
    private String GetLine(int line)
    {

        if (line==-5)
        {
            return "<wa0080";
        }
        if (line==-4)
        {
            return "<end";
        }
        if (line==-3)
        {
            return "["+LEL+"] Event Error./";//This is so we can alert the user when some event doesn't exist.
        }
        if (line==-2)
        {
            return "<end";//Problem is,if a chatline comes before -1,
                          //it will be ignored,because the -1 is a signal to stop execution.
        }
        try {
            BufferedReader br = new BufferedReader(new InputStreamReader(GaBIEn.GetFile("Event.ptx")));
            String s="";
            while (line>0) {line--; s=br.readLine();}
            br.close();
            return s;
        } catch (Exception ex) {
            Logger.getLogger(MainGame.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }
    private int LookupEvent(int i) {
        int Line=1;
        LEL=i;
        while (true)
        {
            
            String s=GetLine(Line);
            if (s==null)
            {
                System.out.println("Failed lookup for "+i);
                return -4;
            }
            if (s.startsWith("#e"))
                if (ParseInt(s.substring(2,6))==i)
                {
                    return Line;
                }
            Line++;
        }
    }

    private int ParseInt(String substring) {
        int A=substring.charAt(3)-'0';
        int B=substring.charAt(2)-'0';
        int C=substring.charAt(1)-'0';
        int D=substring.charAt(0)-'0';
        C+=D*10;
        B+=C*10;
        A+=B*10;
        return A;
    }

    private void DrawYN(IGrInDriver graphics, boolean b) {
            IImage yesno=graphics.GetImage("Pbm/YesNo.pbm", 0,0,0);
            //offset for yesno signs from backings
            int ox=9;
            int oy=7;
            //offset for yesno backings from top left of screen
            int xx=0;
            int yy=0;
            xx=((graphics.GetWidth()/2)-16)-(yesno.GetWidth()-48);
            yy=(graphics.GetHeight()/2)-yesno.GetHeight();
            if (b)
            {
            graphics.BlitBCKImage(48, 0, yesno.GetWidth()-48, yesno.GetHeight(), xx,yy, yesno);
            }
            graphics.BlitBCKImage(0, 0, 48, yesno.GetHeight()/2, xx+ox,yy+oy, yesno);
            xx=((graphics.GetWidth()/2)+16);
            if (!b)
            {
            graphics.BlitBCKImage(48, 0, yesno.GetWidth()-48, yesno.GetHeight(), xx, yy, yesno);
            }
            graphics.BlitBCKImage(0, yesno.GetHeight()/2, 48, yesno.GetHeight()/2, xx+ox,yy+oy, yesno);
    }

    @Override
    public void StartEvent(int ev) {
        ScriptPoint=LookupEvent(ev)+1;
    }
    //This is a static routine because it's technically global-fade out is done by Opening 
    //before we switch gamestates and do the fade in.
    public static boolean FadeDrawer(int stage,boolean out,IGrInDriver to)
    {
        IImage fade=to.GetImage("Pbm/Fade.pbm", 0, 0, out?0:16);
        boolean ended=true;
        for (int x=0;x<to.GetWidth();x+=16)
        for (int y=0;y<to.GetHeight();y+=16)
        {
            int lstage=stage;
            int dy=to.GetHeight()-y;
            int dx=to.GetWidth()-x;
            int p=(dy/16)+(x/16);
            lstage-=p;
            if (lstage<0) {lstage=0;}
            if (lstage>15) {lstage=15;} else {ended=false;}
        to.BlitBCKImage(lstage*16, 0, 16, 16, x, y, fade);
        }
        return ended;
    }

    private void AdvanceChat() {
        if (CurrentChat.split("\r\n").length>2)
        {
            CurrentChat=CurrentChat.substring(CurrentChat.indexOf("\r\n")+2);
            CurrentChatReveal=CurrentChat.indexOf("\r\n");
        } else {
            MinorState=0;
        }
    }

    private void DrawFigure(IGrInDriver graphics, int PlayerEnergy, int i, int i0) {
        IImage fig=graphics.GetImage("Pbm/Figure.pbm", 0,0,0);
        String ss=""+PlayerEnergy;
        int p=0;
        for (int xx=ss.length()-1;xx>=0;xx--)
        {
            char c=ss.charAt(xx);
            graphics.BlitBCKImage((c-'0')*8,0,8,8,i+p,i0,fig);
            p-=9;
        }
    }
}
