/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.games.editorui;

import java.util.LinkedList;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import javachan.Rect;

/**
 *
 * @author matt
 */
public class UIPanel extends UIElement {
    public IImage Image;
    public int ImageX,ImageY;
    public UIElement Selected;
    public LinkedList<UIElement> Elements=new LinkedList<UIElement>();

    //ox,oy specify where this element is being drawn.the bounds are used in calculating this.
    //the root panel gets a ox,oy of 0,0,for obvious reasons.
    @Override
    public void UpdateAndDraw(int ox, int oy,double DeltaTime,boolean select,IGrInDriver igd) {
        if (Image!=null)
            igd.BlitImage(ImageX, ImageY, Bounds.width, Bounds.height, ox,oy, Image);
        for (UIElement uie : Elements)
        {
            Rect r=uie.GetBounds();
            uie.UpdateAndDraw(ox+r.x, oy+r.y,DeltaTime,(Selected==uie)&&select, igd);
        }
    }
    //The click is within the (0,0,my width-1,my height-1) range.
    @Override
    public void HandleClick(int x, int y) {
        Selected=null;
        for (UIElement uie : Elements)
        {
                Rect r=uie.GetBounds();
            if (r.contains(x, y))
            {
                Selected=uie;//Note that it's important Selected is given to the element returning a numpad value.
                uie.HandleClick(x-r.x, y-r.y);
                return;
            }
        }
    }
    @Override
    public void HandleDrag(int x, int y) {
        for (UIElement uie : Elements)
        {
                Rect r=uie.GetBounds();
            if (r.contains(x, y))
            {
                uie.HandleDrag(x-r.x, y-r.y);
                return;
            }
        }
    }

}
